#!/usr/bin/python
# -*- coding: utf-8 -*-

#  Copyright © 2013  B. Clausius <barcc@gmx.de>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

from __future__ import print_function, division

import os

from gi.repository import GObject
from gi.repository import Gedit

from . import utils
from . import suite_main
import projects.settings
assert not os.path.exists(projects.settings.DataFile().filename)

def ls():
    reload(utils)
    reload(suite_main)
    utils.ls(suite_main)
    
def run(name=None):
    reload(utils)
    reload(suite_main)
    utils.run(suite_main, name)
    
class TestsApp(GObject.Object, Gedit.AppActivatable):
    __gtype_name__ = "TestsApp"
    app = GObject.property(type=Gedit.App)
    
    def __init__(self):
        GObject.Object.__init__(self)
        
    def do_activate(self):
        print('######## activate projects tests plugin ########')
        assert not os.path.exists(projects.settings.DataFile().filename)
        run()
        
    def do_deactivate(self):
        print('######## deactivate projects tests plugin ########')
        utils.remove_projects()
        os.remove(projects.settings.DataFile().filename)
        
        

